// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- REGULAR PAGE UPDATING -- //

function thumbstrips_resetUpdaters() 
{   
	if (thumbstrips_recording === false) 
	{	
        thumbstripsSetCurrentWebPageNode(filmstripManager.GetWebPageNodeByUrl(GetCurrentUrl()));		
		return;
	}
	
	thumbstrips_clearUpdaters();   
	thumbstrips_setUpdaters();
}

// This removes the updatePage timer, that's it
function thumbstrips_clearUpdaters() 
{
	// A separate function because it's called from multiple places
	window.clearInterval(thumbstrips_pageUpdater);
}

function thumbstrips_setUpdaters() 
{
	// Set all updaters that rely on the page location (but fire them once before)
	// Commenting this out fixes the font problem
	var pageUpdateFrequency = thumbstrips_prefs.getIntPref("time.page_update_frequency");	
	
	thumbstrips_pageUpdater = window.setInterval(thumbstrips_updatePage, (pageUpdateFrequency * 1000));
}

var thumbstripsUpdateCounterMaxValue = 10;
var thumbstripsUpdateCounter = thumbstripsUpdateCounterMaxValue;

function thumbstrips_updatePage() 
{
	if(thumbstrips_recording==true)
	{
        if(!thumbstrips_GetDoNotRecordList().IsInList(GetCurrentUrl(), false))
        {         
            var currentNode = thumbstripsGetCurrentWebPageNode();
            
            if(currentNode==null)
	        {
	            var filmstripManager = thumbstrips_GetFilmstrip();

	            currentNode = filmstripManager.GetWebPageNodeByUrl(GetCurrentUrl());
	    
	            if(currentNode==null)
	            {
	                currentNode = filmstripManager.AddOrUpdateWebPageNode(GetCurrentUrl());
	                filmstripManager.UpdateWebsiteNode(currentNode);
                }
        	        
	            thumbstripsSetCurrentWebPageNode(currentNode);
	        }
	        
	        currentNode.UpdateContents(content);
            currentNode = null;
	    
            var renderer = new thumbstripsFilmstripRenderer();
            renderer.Draw(false);
            renderer = null;
        }
    }
}