// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// All Rights Reserved. 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- INITIALIZATION -- //
var filmstripTag_filmstrip          = "filmstrip";
var filmstripTag_CustomSort         = "CustomSort";
var filmstripTag_PageThumbnails     = "PageThumbnails";
var filmstripTag_PageThumbnail      = "PageThumbnail";
var filmstripTag_PageVisits         = "PageVisits";
var filmstripTag_PageVisit          = "PageVisit";
var filmstripTag_ThumbnailComment   = "Comment";

var filmstripAttribute_FileVersion  = "FileVersion";
var filmstripAttribute_SourceUrl    = "SourceUrl";
var filmstripAttribute_Domain       = "Domain";
/**
 * An object that listens for changes in browser location, preferences, etc.
 */
function thumbstripsFilmstripManager()
{
    this.m_hasInitializedCustomSort = false;
    this.m_filmstripManager = null;
    this.m_thumbnailArray = new thumbstripsWebPageThumbnailArray();
}

thumbstripsFilmstripManager.prototype.Initialize = thumbstripsFilmstripManagerInitialize;
thumbstripsFilmstripManager.prototype.SetFileVersion = thumbstripsFilmstripManagerSetFileVersion;
thumbstripsFilmstripManager.prototype.Load = thumbstripsFilmstripManagerLoad;
thumbstripsFilmstripManager.prototype.LoadFromFile = thumbstripsFilmstripManagerLoadFromFile;
thumbstripsFilmstripManager.prototype.DoesFileExist = thumbstripsFilmstripManagerDoesFileExist;
thumbstripsFilmstripManager.prototype.Save = thumbstripsFilmstripManagerSave;
thumbstripsFilmstripManager.prototype.SaveToFile = thumbstripsFilmstripManagerSaveToFile;
thumbstripsFilmstripManager.prototype.AddOrUpdateWebPageNode = thumbstripsFilmstripManagerAddOrUpdateWebPageNode;
thumbstripsFilmstripManager.prototype.GetWebPageNodeByUrl = thumbstripsFilmstripManagerGetWebPageNodeByUrl;
thumbstripsFilmstripManager.prototype.UpdateWebsiteNode = thumbstripsFilmstripManagerUpdateWebsiteNode;
thumbstripsFilmstripManager.prototype.UpdateVisitInformation = thumbstripsFilmstripManagerUpdateVisitInformation;
thumbstripsFilmstripManager.prototype.UpdateWebPageThumbnail = thumbstripsFilmstripManagerUpdateWebPageThumbnail;
thumbstripsFilmstripManager.prototype.UpdatePageTextNode = thumbstripsFilmstripManagerUpdatePageTextNode;
thumbstripsFilmstripManager.prototype.UpdateWebPageThumbnailNode = thumbstripsFilmstripManagerUpdateWebPageThumbnailNode;
thumbstripsFilmstripManager.prototype.UpdateNumberOfVisitsNode = thumbstripsFilmstripManagerUpdateNumberOfVisitsNode;
thumbstripsFilmstripManager.prototype.UpdateTimeOnPageNode = thumbstripsFilmstripManagerUpdateTimeOnPageNode;
thumbstripsFilmstripManager.prototype.UpdateScrollNodes = thumbstripsFilmstripManagerUpdateScrollNodes;
thumbstripsFilmstripManager.prototype.UpdateCommentNode = thumbstripsFilmstripManagerUpdateCommentNode;
thumbstripsFilmstripManager.prototype.Serialize = thumbstripsFilmstripManagerSerialize;
thumbstripsFilmstripManager.prototype.ClearContents = thumbstripsFilmstripManagerClearContents;
thumbstripsFilmstripManager.prototype.ConvertToCurrentFileVersion = thumbstripsFilmstripManagerConvertToCurrentFileVersion;
thumbstripsFilmstripManager.prototype.ConvertThumbstripsFileFrom10 = thumbstripsFilmstripManagerConvertThumbstripsFileFrom10;
thumbstripsFilmstripManager.prototype.RemoveWebsiteVisit = thumbstripsFilmstripManagerRemoveWebsiteVisit;
thumbstripsFilmstripManager.prototype.RemoveWebsiteNode = thumbstripsFilmstripManagerRemoveWebsiteNode;
thumbstripsFilmstripManager.prototype.RelocateThumbnailBeforeNode = thumbstripsFilmstripManagerRelocateThumnbailBeforeNode;
thumbstripsFilmstripManager.prototype.RelocateThumnbailToEnd = thumbstripsFilmstripManagerRelocateThumnbailToEnd;
thumbstripsFilmstripManager.prototype.GetCustomSort = thumbstripsFilmstripManagerGetCustomSort;
thumbstripsFilmstripManager.prototype.GetSortedVisits = thumbstripsFilmstripManagerGetSortedVisits;
thumbstripsFilmstripManager.prototype.InitializeCustomSort = thumbstripsFilmstripManagerInitializeCustomSort;
thumbstripsFilmstripManager.prototype.SetSortMode = thumbstripsFilmstripManagerSetSortMode;
thumbstripsFilmstripManager.prototype.GetSortMode = thumbstripsFilmstripManagerGetSortMode;
thumbstripsFilmstripManager.prototype.LoadThumbnailsIntoMemory = thumbstripsFilmstripManagerLoadThumbnailsIntoMemory;

function thumbstripsFilmstripManagerDoesFileExist(parentDirectory, fileName)
{
    var retVal = false;
    
    var targetFile = Components.classes["@mozilla.org/file/directory_service;1"]
                   .getService(Components.interfaces.nsIProperties)
                   .get("UChrm", Components.interfaces.nsIFile);
    
    // History file stored at <user's chrome>\filmstrips\<file_name><file_ext>
    targetFile.append(parentDirectory, fileName);
    targetFile.append(fileName);
    
    if(targetFile.exists()) 
    {
        retVal = true;
    }
    
    return retVal;
}

function thumbstripsFilmstripManagerInitialize(addRootNode)
{
    this.m_filmstripManager = new thumbstripsXmlHelper(); 

    if(addRootNode==true)
    {
        this.m_filmstripManager.Initialize("", filmstripTag_filmstrip);  
        this.SetFileVersion();
    }
    else
        this.m_filmstripManager.Initialize("","");  
}

function thumbstripsFilmstripManagerSetFileVersion()
{
    if(this.m_filmstripManager!=null)
    {
        if(this.m_filmstripManager.m_xmlData!=null)
        {
            if(this.m_filmstripManager.m_xmlData.documentElement!=null)
            {
                this.m_filmstripManager.m_xmlData.documentElement.setAttribute(filmstripAttribute_FileVersion, "2");
            }
        }
    }
}

function thumbstripsFilmstripManagerLoad()
{        
    this.ClearContents();
    
    if(this.DoesFileExist(thumbstrips_xmlDirectory, "_ThumbStrips History from Last Browser Session.film"))
    {
        this.Initialize(false);
        this.m_filmstripManager.Load(thumbstrips_xmlDirectory, "_ThumbStrips History from Last Browser Session.film");
    }
    else
    {
        this.Initialize(true);
    }
    
    this.ConvertToCurrentFileVersion();  
    this.LoadThumbnailsIntoMemory();  
}

function thumbstripsFilmstripManagerLoadFromFile(targetFile)
{
    this.ClearContents();

    if(targetFile.exists())
    {
        this.Initialize(false);
        this.m_filmstripManager.LoadFromFile(targetFile);
    }
    else
    {
        this.Initialize(true);
    }

    this.ConvertToCurrentFileVersion();  
    this.LoadThumbnailsIntoMemory();  
} 
    
function thumbstripsFilmstripManagerSave()
{
    if(this.m_filmstripManager!=null)
    {
        this.m_filmstripManager.Save(thumbstrips_xmlDirectory, "_ThumbStrips History from Last Browser Session.film");
    }
}

function thumbstripsFilmstripManagerSaveToFile(targetFile)
{
    if(this.m_filmstripManager!=null)
    {
        this.m_filmstripManager.SaveToFile(targetFile);
    }
}

function thumbstripsFilmstripManagerAddOrUpdateWebPageNode(targetUrl, beginNewVisit)
{        
    var webPageNode = this.GetWebPageNodeByUrl(targetUrl);
    
    if(webPageNode==null)
    {
        webPageNode = new thumbstripsWebPageNode(targetUrl, null, 0, 0, null, 0);
    }
    else
    {
        if(beginNewVisit==true)
            webPageNode.BeginNewVisit();
        else
            webPageNode.UpdateCurrentVisit(false);
    }
    
    return webPageNode;
}

function thumbstripsFilmstripManagerUpdateWebsiteNode(thumbstripsWebPageNode, targetUrl)
{     
    var numberOfVisits = 0;
        
    if(this.m_filmstripManager!=null)
    {
        if(thumbstripsWebPageNode!=null)
        {
            if(thumbstripsWebPageNode.m_visitInformation!=null)
            {
                this.UpdateVisitInformation(thumbstripsWebPageNode.m_visitInformation);      
                numberOfVisits = thumbstripsWebPageNode.m_visitInformation.m_visitList.length;
            }
        }
            
        var targetThumbnail = this.m_thumbnailArray.FindByUrl(targetUrl);
         
        if(targetThumbnail!=null)
        {
            if(numberOfVisits==0)
                numberOfVisits = targetThumbnail.m_numberOfVisits;

            this.UpdateWebPageThumbnail(targetThumbnail, numberOfVisits);
        }         
    }
}

function thumbstripsFilmstripManagerGetWebPageNodeByUrl(targetUrl)
{   
    var retVal = null;
    var foundVisits = this.m_filmstripManager.m_xmlData.documentElement.selectNodes("//PageVisits/PageVisit[@" + filmstripAttribute_SourceUrl + "='" + targetUrl + "']");
        
    if(foundVisits!=null && foundVisits.length > 0)
    {        
        retVal = new thumbstripsWebPageNode(targetUrl, null, 0, 0, null, 0);
        retVal.m_visitInformation.ReadFromXml(foundVisits);
    }
    else
    {
        retVal = null;
    }
    
    return retVal;
}

function thumbstripsFilmstripManagerUpdateWebPageThumbnail(thumbstripsWebPageThumbnail, numberOfVisits)
{
    if(this.m_filmstripManager!=null && thumbstripsWebPageThumbnail!=null)
    {        
        var pageThumbnailsNode = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("PageThumbnails");

        if(pageThumbnailsNode==null)
        {
            pageThumbnailsNode = this.m_filmstripManager.m_xmlData.createElement("PageThumbnails");    
            this.m_filmstripManager.m_xmlData.documentElement.appendChild(pageThumbnailsNode);
        }

        var pageThumbnailNode = pageThumbnailsNode.selectSingleNode("PageThumbnail[@" + filmstripAttribute_SourceUrl + "='" + thumbstripsWebPageThumbnail.m_url + "']");
        
        if(pageThumbnailNode==null)
        {
            // create the web page node
            pageThumbnailNode = this.m_filmstripManager.m_xmlData.createElement("PageThumbnail");
            
            var sourceUrlAttribute = this.m_filmstripManager.m_xmlData.createAttribute(filmstripAttribute_SourceUrl);
            sourceUrlAttribute.value = thumbstripsWebPageThumbnail.m_url;
            pageThumbnailNode.setAttributeNode(sourceUrlAttribute);
            
            var domainAttribute = this.m_filmstripManager.m_xmlData.createAttribute(filmstripAttribute_Domain);
            domainAttribute.value = thumbstripsWebPageThumbnail.m_domain;
            pageThumbnailNode.setAttributeNode(domainAttribute);
            
            var lastUpdateDateAttribute = this.m_filmstripManager.m_xmlData.createAttribute("LastUpdate");
            lastUpdateDateAttribute.value = thumbstripsWebPageThumbnail.m_lastUpdateDate;
            pageThumbnailNode.setAttributeNode(lastUpdateDateAttribute);
            pageThumbnailsNode.appendChild(pageThumbnailNode);
        }

        this.UpdatePageTextNode(thumbstripsWebPageThumbnail, pageThumbnailNode);
        this.UpdateWebPageThumbnailNode(thumbstripsWebPageThumbnail, pageThumbnailNode);
        this.UpdateNumberOfVisitsNode(numberOfVisits, pageThumbnailNode);      
        this.UpdateTimeOnPageNode(thumbstripsWebPageThumbnail, pageThumbnailNode);
        this.UpdateScrollNodes(thumbstripsWebPageThumbnail, pageThumbnailNode);
        this.UpdateCommentNode(thumbstripsWebPageThumbnail, pageThumbnailNode);
    }
}

function thumbstripsFilmstripManagerUpdatePageTextNode(webPageThumbnailNode, pageThumbnailElement)
{   
    if(pageThumbnailElement!=null && webPageThumbnailNode!=null)
    {   
        if(webPageThumbnailNode.m_pageText!=null)
        {
            var pageTextNode = pageThumbnailElement.selectSingleNode("descendant::PageText");

            if(pageTextNode!=null)
            {                
                for(var i = 0; i < pageTextNode.childNodes.length; i++)
                {                    
                    if(pageTextNode.childNodes[i].nodeType==3) //TEXT_SECTION_NODE
                    {
                        pageTextNode.childNodes[i].nodeValue = "<!--" + webPageThumbnailNode.m_pageText + "-->";
                    }
                }
            }
            else
            {
                // create the page text node
                pageTextNode = pageThumbnailElement.ownerDocument.createElement("PageText");                
                var pageTextData = pageThumbnailElement.ownerDocument.createTextNode(webPageThumbnailNode.m_pageText);
                pageTextNode.appendChild(pageTextData);
                pageThumbnailElement.appendChild(pageTextNode);
            }
        }
    }
}

function thumbstripsFilmstripManagerUpdateWebPageThumbnailNode(webPageThumbnailNode, pageThumbnailElement)
{   
    if(pageThumbnailElement!=null && webPageThumbnailNode!=null)
    {   
        if(webPageThumbnailNode.m_pageThumbnail!=null)
        {
            var thumbnailNode = pageThumbnailElement.selectSingleNode("descendant::Thumbnail");
            
            if(thumbnailNode!=null)
            {                
                for(var i = 0; i < thumbnailNode.childNodes.length; i++)
                {                    
                    if(thumbnailNode.childNodes[i].nodeType==4) //CDATA_SECTION_NODE
                    {
                        thumbnailNode.childNodes[i].nodeValue = webPageThumbnailNode.m_pageThumbnail.ToDataUrl();
                    }
                }
            }
            else
            {
                // create the page thumbnail node
                thumbnailNode = pageThumbnailElement.ownerDocument.createElement("Thumbnail");  
                var thumbnailData = pageThumbnailElement.ownerDocument.createCDATASection(webPageThumbnailNode.m_pageThumbnail.ToDataUrl());
                thumbnailNode.appendChild(thumbnailData);
                pageThumbnailElement.appendChild(thumbnailNode);
            }
        }
    }
}

function thumbstripsFilmstripManagerUpdateNumberOfVisitsNode(numberOfVisits, pageThumbnailElement)
{
    if(pageThumbnailElement!=null)
    {   
        var numberOfVisitsElement = pageThumbnailNode.selectSingleNode("descendant::NumberOfVisits");

        if(numberOfVisitsElement!=null)
        {
            for(var i = 0; i < numberOfVisitsElement.childNodes.length; i++)
            {                    
                if(numberOfVisitsElement.childNodes[i].nodeType==3) //CDATA_SECTION_NODE
                {
                    numberOfVisitsElement.childNodes[i].nodeValue = numberOfVisits;
                    break;
                }
            }
        }
        else
        {
            numberOfVisitsElement = pageThumbnailElement.ownerDocument.createElement("NumberOfVisits");
            var visitCountText = pageThumbnailElement.ownerDocument.createTextNode(numberOfVisits);
            numberOfVisitsElement.appendChild(visitCountText);
            pageThumbnailElement.appendChild(numberOfVisitsElement);
        }
    }
}

function thumbstripsFilmstripManagerUpdateTimeOnPageNode(webPageThumbnailNode, pageThumbnailElement)
{
    if(pageThumbnailElement!=null && webPageThumbnailNode!=null)
    {   
        var timeOnPage = pageThumbnailElement.selectSingleNode("descendant::TimeOnPage");
   
        if(timeOnPage!=null)
        {
            for(var i = 0; i < timeOnPage.childNodes.length; i++)
            {                    
                if(timeOnPage.childNodes[i].nodeType==3) //CDATA_SECTION_NODE
                {
                    timeOnPage.childNodes[i].nodeValue = webPageThumbnailNode.m_visitTimeInMilliseconds;
                    break;
                }
            }
        }
        else
        {
            timeOnPage = pageThumbnailElement.ownerDocument.createElement("TimeOnPage");
            var visitTimeText = pageThumbnailElement.ownerDocument.createTextNode(webPageThumbnailNode.m_visitTimeInMilliseconds);
            timeOnPage.appendChild(visitTimeText);
            pageThumbnailElement.appendChild(timeOnPage);
        }
    }
}

function thumbstripsFilmstripManagerUpdateScrollNodes(webPageThumbnailNode, pageThumbnailElement)
{        
    if(pageThumbnailElement!=null && webPageThumbnailNode!=null)
    {   
        var scrollXNode = pageThumbnailElement.selectSingleNode("descendant::ScrollX");
   
        if(scrollXNode!=null)
        {
            for(var i = 0; i < scrollXNode.childNodes.length; i++)
            {                    
                if(scrollXNode.childNodes[i].nodeType==3) //TEXT_SECTION_NODE
                {
                    scrollXNode.childNodes[i].nodeValue = webPageThumbnailNode.m_scrollX;
                    break;
                }
            }
        }
        else
        {
            scrollXNode = pageThumbnailElement.ownerDocument.createElement("ScrollX");
            var scrollXText = pageThumbnailElement.ownerDocument.createTextNode(webPageThumbnailNode.m_scrollX);
            scrollXNode.appendChild(scrollXText);
            pageThumbnailElement.appendChild(scrollXNode);
        }
    
        var scrollYNode = pageThumbnailElement.selectSingleNode("descendant::ScrollY");
   
        if(scrollYNode!=null)
        {
            for(var i = 0; i < scrollYNode.childNodes.length; i++)
            {                    
                if(scrollYNode.childNodes[i].nodeType==3) //TEXT_SECTION_NODE
                {
                    scrollYNode.childNodes[i].nodeValue = webPageThumbnailNode.m_scrollY;
                    break;
                }
            }
        }
        else
        {
            scrollYNode = pageThumbnailElement.ownerDocument.createElement("ScrollY");          
            var scrollYText = pageThumbnailElement.ownerDocument.createTextNode(webPageThumbnailNode.m_scrollY);
            scrollYNode.appendChild(scrollYText);
            pageThumbnailElement.appendChild(scrollYNode);
        }
    }
}

function thumbstripsFilmstripManagerUpdateCommentNode(webPageThumbnailNode, pageThumbnailElement)
{        
    if(pageThumbnailElement!=null && webPageThumbnailNode!=null)
    {   
        var commentNode = pageThumbnailElement.selectSingleNode("descendant::" + filmstripTag_ThumbnailComment);
   
        if(commentNode!=null)
        {
            for(var i = 0; i < commentNode.childNodes.length; i++)
            {                    
                if(commentNode.childNodes[i].nodeType==3) //TEXT_SECTION_NODE
                {
                    commentNode.childNodes[i].nodeValue = webPageThumbnailNode.m_comment;
                    break;
                }
            }
        }
        else
        {
            commentNode = pageThumbnailElement.ownerDocument.createElement(filmstripTag_ThumbnailComment);
            var commentText = pageThumbnailElement.ownerDocument.createTextNode(webPageThumbnailNode.m_comment);
            commentNode.appendChild(commentText);
            pageThumbnailElement.appendChild(commentNode);
        }
    }
}

function thumbstripsFilmstripManagerUpdateVisitInformation(thumbstripsVisitInformation)
{ 
    if(thumbstripsVisitInformation!=null)
    {
        // create the web page node
        var pageVisitsElement = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("//PageVisits");
    
        if(pageVisitsElement==null)
        {
            pageVisitsElement = this.m_filmstripManager.m_xmlData.createElement("PageVisits");
            this.m_filmstripManager.m_xmlData.documentElement.appendChild(pageVisitsElement);
        }
    
        var visitIndex = 0;
        
        for(var visitItem in thumbstripsVisitInformation.m_visitList)
        {         
            var pageVisitElement = pageVisitsElement.selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + thumbstripsVisitInformation.m_url + "' and @VisitIndex=" + visitIndex + "]");
            
            if(pageVisitElement==null)
            {
                pageVisitElement = pageVisitsElement.ownerDocument.createElement("PageVisit");
                
                var sourceUrlAttribute = pageVisitsElement.ownerDocument.createAttribute(filmstripAttribute_SourceUrl);
                sourceUrlAttribute.value = thumbstripsVisitInformation.m_url;
                pageVisitElement.setAttributeNode(sourceUrlAttribute);
                
                var domainAttribute = pageVisitsElement.ownerDocument.createAttribute(filmstripAttribute_Domain);
                domainAttribute.value = thumbstripsVisitInformation.m_domain;
                pageVisitElement.setAttributeNode(domainAttribute);
                
                var visitDateAttribute = pageVisitsElement.ownerDocument.createAttribute("VisitDate");
                visitDateAttribute.value = thumbstripsVisitInformation.m_visitList[visitItem];
                pageVisitElement.setAttributeNode(visitDateAttribute);                
                
                var visitIndexAttribute = pageVisitsElement.ownerDocument.createAttribute("VisitIndex");
                visitIndexAttribute.value = visitItem;
                pageVisitElement.setAttributeNode(visitIndexAttribute);                
                pageVisitsElement.appendChild(pageVisitElement); 
                
                if(this.GetSortMode()==sortModeManually)
                {
                    var sortElement = this.GetCustomSort();
                    sortElement.appendChild(pageVisitElement.cloneNode(true));
                }
            }
            
            visitIndex = visitIndex + 1;
        }
    }
}

function thumbstripsFilmstripManagerSerialize()
{
    var retVal = "";
    
    if(this.m_filmstripManager!=null)
    {
        if(this.m_filmstripManager.m_xmlData!=null)
        {
            retVal = this.m_filmstripManager.Serialize(this.m_filmstripManager.m_xmlData.documentElement);
        }
    }
    
    return retVal;
}

function thumbstripsFilmstripManagerClearContents()
{
    if(this.m_filmstripManager!=null)
    {
        this.m_thumbnailArray.ClearContents();
        
        if(this.m_filmstripManager.m_xmlData!=null)
        {
            this.m_filmstripManager.m_xmlData.removeChild(this.m_filmstripManager.m_xmlData.documentElement);
            this.m_filmstripManager.m_xmlData = null;
            this.Initialize(true);
        }
    }
    
    this.m_hasInitializedCustomSort = false;
}

function thumbstripsFilmstripManagerConvertToCurrentFileVersion()
{
    if(this.m_filmstripManager!=null)
    {
        if(this.m_filmstripManager.m_xmlData!=null)
        {
            if(this.m_filmstripManager.m_xmlData.documentElement!=null)
            {
                var currentFileVersion = this.m_filmstripManager.m_xmlData.documentElement.getAttributeNode("FileVersion");
                
                if(currentFileVersion==null)
                {
                    this.ConvertThumbstripsFileFrom10();
                }
                else if(currentFileVersion.nodeValue=="2")
                {

                }    
                
                this.SetFileVersion();            
            }
        }
    }
}

function thumbstripsFilmstripManagerConvertThumbstripsFileFrom10()
{
	var xmlNodesFirstVisit = this.m_filmstripManager.m_xmlData.getElementsByTagName(thumbstrips_xmlNodeListFirstVisit)[0].childNodes;
		
	function extract(xmlNode, xmlTag) 
	{
		return thumbstrips_simpleTrim(xmlNode.getElementsByTagName(xmlTag)[0].childNodes[0].textContent);
	}
	
	for (var i = 0; i < xmlNodesFirstVisit.length; i++) 
	{
		var xmlNode = xmlNodesFirstVisit[i];
		var webPageNode = new thumbstripsWebPageNode("", null, 0, 0, null, 0);
		
		try 
		{
			if (xmlNode.nodeName !== thumbstrips_xmlNode) 
			{
				continue;
			}
		
		    var thumbnailToAdd = new thumbstripsWebPageThumbnailNode(extract(xmlNode, thumbstrips_xmlUrl), null, 0, 0, 0);
		    var dataUrl = extract(xmlNode, thumbstrips_xmlThumbnail);
		    thumbnailToAdd.m_pageThumbnail.InitializeFromDataUrl(thumbnailToAdd, dataUrl);
		    
		    thumbnailToAdd.m_title = extract(xmlNode, thumbstrips_xmlTitle);
		    thumbnailToAdd.m_domain = extract(xmlNode, thumbstrips_xmlDomain);
		    thumbnailToAdd.m_pageText = extract(xmlNode, thumbstrips_xmlPageText);
		    thumbnailToAdd.m_scrollX = extract(xmlNode, thumbstrips_xmlScrollX);
			thumbnailToAdd.m_scrollY = extract(xmlNode, thumbstrips_xmlScrollY);
			
			var visitList = extract(xmlNode, thumbstrips_xmlVisitList).split(",");

			for(var j = 0; j < visitList.length; j++)
			{
			    webPageNode.m_visitInformation.m_url = thumbnailToAdd.m_url;
			    webPageNode.m_visitInformation.m_domain = thumbnailToAdd.m_domain;
			    webPageNode.m_visitInformation.m_visitList[j] = visitList[j];
            }
            
			thumbnailToAdd.m_visitTimeInMilliseconds = extract(xmlNode, thumbstrips_xmlVisitTime);
			
			this.m_thumbnailArray.UpdateThumbnail(thumbnailToAdd);
			this.UpdateWebsiteNode(webPageNode, thumbnailToAdd.m_url);			
		} 
		catch (e) 
		{
			thumbstrips_log("loading first visit, ONE NODE FAILED, i = " + i);
			thumbstrips_log(e);
		}		
	}
	
	// now remove the old stuff
	var nodeToRemove = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("length");
	
	if(nodeToRemove!=null)
	{
	    this.m_filmstripManager.m_xmlData.documentElement.removeChild(nodeToRemove);
	}
	
	var nodeToRemove = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("nodelistfirstvisit");
	
	if(nodeToRemove!=null)
	{
	    this.m_filmstripManager.m_xmlData.documentElement.removeChild(nodeToRemove);
	}
	
	var nodeToRemove = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("nodelistlastvisit");
	
	if(nodeToRemove!=null)
	{
	    this.m_filmstripManager.m_xmlData.documentElement.removeChild(nodeToRemove);
	}

	var nodeToRemove = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("nodelisteveryvisit");
	
	if(nodeToRemove!=null)
	{
	    this.m_filmstripManager.m_xmlData.documentElement.removeChild(nodeToRemove);
	}
}

function thumbstripsFilmstripManagerRemoveWebsiteVisit(sourceUrl, visitIndex)
{
    var pageVisitsElement = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("//PageVisits");
    
    if(pageVisitsElement!=null)
    {
        if(pageVisitsElement.selectNodes("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "']").length > 1)
        {
            var visitToRemove = pageVisitsElement.selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "' and @VisitIndex='" + visitIndex + "']");
    
            if(visitToRemove!=null)
            {
                pageVisitsElement.removeChild(visitToRemove);
            }
        }
        else
        {
            this.RemoveWebsiteNode(sourceUrl);
        }
        
        var sortVisitToRemove = this.GetCustomSort().selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "' and @VisitIndex='" + visitIndex + "']");
        
        if(sortVisitToRemove!=null)
        {
            this.GetCustomSort().removeChild(sortVisitToRemove);
        }
    }
}

function thumbstripsFilmstripManagerRemoveWebsiteNode(sourceUrl)
{
    var pageThumbnailsElement = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("//PageThumbnails");

    if(pageThumbnailsElement!=null)
    {
        var thumbnailToRemove = pageThumbnailsElement.selectSingleNode("descendant::PageThumbnail[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "']");
    
        if(thumbnailToRemove!=null)
        {
            pageThumbnailsElement.removeChild(thumbnailToRemove);
        }
    }

    var pageVisitsElement = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("//PageVisits");
    
    if(pageVisitsElement!=null)
    {
        var visitsToRemove = pageVisitsElement.selectNodes("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "']");
    
        for(var i = visitsToRemove.length - 1; i > -1; i--)
        {
            pageVisitsElement.removeChild(visitsToRemove[i]);
        }
    }
    
    var sortElement = this.GetCustomSort();
    var sortVisitsToRemove = sortElement.selectNodes("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + sourceUrl + "']");
    
    if(sortVisitsToRemove!=null)
    {
        for(var i = sortVisitsToRemove.length -1; i > -1; i--)
        {
            sortElement.removeChild(sortVisitsToRemove[i]);
        }
    }
}

function thumbstripsFilmstripManagerRelocateThumnbailBeforeNode(thumbnailToMove, thumbnailToInsertBefore)
{
    var sortElement = this.GetCustomSort();
    
    if(sortElement!=null)
    {
        var thumbnailToMoveElement = sortElement.selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + thumbnailToMove + "']");
        var thumbnailToInsertBeforeElement = sortElement.selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + thumbnailToInsertBefore + "']");

        if(thumbnailToMoveElement!=null)
        {    
            sortElement.removeChild(thumbnailToMoveElement);
        }
        
        if(thumbnailToMoveElement!=null && thumbnailToInsertBeforeElement!=null)
        {
            sortElement.insertBefore(thumbnailToMoveElement, thumbnailToInsertBeforeElement);    
        }      
    }
}

function thumbstripsFilmstripManagerRelocateThumnbailToEnd(thumbnailToMove)
{
    var sortElement = this.GetCustomSort();
    
    if(sortElement!=null)
    {
        var thumbnailToMoveElement = sortElement.selectSingleNode("descendant::PageVisit[@" + filmstripAttribute_SourceUrl + "='" + thumbnailToMove + "']");

        if(thumbnailToMoveElement!=null)
        {    
            sortElement.removeChild(thumbnailToMoveElement);
            sortElement.appendChild(thumbnailToMoveElement);
        }      
    }
}

function thumbstripsFilmstripManagerGetCustomSort()
{
    var sortElement = this.m_filmstripManager.m_xmlData.documentElement.selectSingleNode("descendant::Sort");
    
    if(sortElement==null)
    {
        sortElement = this.m_filmstripManager.m_xmlData.createElement("Sort");
        this.m_filmstripManager.m_xmlData.documentElement.appendChild(sortElement);
    }
    
    return sortElement;
}

function thumbstripsFilmstripManagerGetSortedVisits(sortMode)
{
    var retVal = new Array();
    
    allVisitNodes = thumbstrips_GetFilmstrip().m_filmstripManager.m_xmlData.documentElement.selectNodes("//PageVisits/PageVisit");
   	
	if (sortMode == sortModeEveryVisit) 
	{	  
	    for(var i = 0; i < allVisitNodes.length; i++)
	    {
	        retVal[i] = allVisitNodes[i];
        }             
	}
	else if (sortMode == sortModeLastVisit)
  	{
  	    var processedUrls = new Array();
  	    var urlCounter = 0;
  	    var tempList = new Array();
  	    
        for(var i = allVisitNodes.length - 1; i > -1; i--)
        {
            if(processedUrls[allVisitNodes[i].getAttribute(filmstripAttribute_SourceUrl)]==null)
            {
                tempList[urlCounter] = allVisitNodes[i];
                urlCounter = urlCounter + 1;
                processedUrls[allVisitNodes[i].getAttribute(filmstripAttribute_SourceUrl)] = true;                
            }
        }  	
        
        processedUrls = null;
        
        urlCounter = 0;
        
        for(var i = tempList.length - 1; i > -1; i--)
        {
            retVal[urlCounter] = tempList[i]; 
            urlCounter = urlCounter + 1;
        }
	}
	else if (sortMode == sortModeFirstVisit)
	{
  	    var processedUrls = new Array();
  	    var urlCounter = 0;
  	    
        for(var i = 0; i < allVisitNodes.length; i++)
        {
            if(processedUrls[allVisitNodes[i].getAttribute(filmstripAttribute_SourceUrl)]==null)
            {
                retVal[urlCounter] = allVisitNodes[i];
                urlCounter = urlCounter + 1;
                processedUrls[allVisitNodes[i].getAttribute(filmstripAttribute_SourceUrl)] = true;                
            }
        }  	
        
        processedUrls = null;
	}
    else
    {
        var sortElement = this.GetCustomSort();
        
        for(var i = 0; i < sortElement.childNodes.length; i++)            
            retVal[i] = sortElement.childNodes[i];
    }
    
    allVisitNodes = null;
    
    return retVal;
}

function thumbstripsFilmstripManagerInitializeCustomSort()
{
    var sortManager = new thumbstripsSortManager();
    var currentSortMode = sortManager.GetSortMode();
    
    if(currentSortMode!=sortModeManually)
    {
        var sortElement = this.GetCustomSort();
                        
        if(sortElement.childNodes.length > 0)
        {
            var continueChangingSort = true;
            
            if(this.m_hasInitializedCustomSort==false)
            {
                continueChangingSort = confirm("You are about to create a new manual sort.\nPress Ok to continue and overwrite your existing manual sort,\nor press Cancel to retain the existing manual sort.");
            }
            
            if(continueChangingSort==true)
            {
                for(var i = sortElement.childNodes.length - 1; i >= 0; i--)
                    sortElement.removeChild(sortElement.childNodes[i]);    
            }
        }
        
        sortManager.ShowManualSort(true);
        this.m_hasInitializedCustomSort = true;
        
        if(sortElement.childNodes.length==0)
        {        
            currentSortOrder = this.GetSortedVisits(currentSortMode);

            for(var i = 0; i < currentSortOrder.length; i++)
	        {
                sortElement.appendChild(currentSortOrder[i].cloneNode(true));	    
            }
            
            currentSortOrder = null;
        }
    }
    
    sortManager = null;
}

function thumbstripsFilmstripManagerSetSortMode(sortMode)
{
    var sortElement = this.GetCustomSort();
    
    if(sortMode==sortModeManually)
    {
        sortElement.setAttribute("SortMode", "Manual");
    }
    else if(sortMode==sortModeFirstVisit)
    {
        sortElement.setAttribute("SortMode", "First Visit");
    }
    else if(sortMode==sortModeLastVisit)
    {
        sortElement.setAttribute("SortMode", "Last Visit");
    }
    else if(sortMode==sortModeEveryVisit)
    {
        sortElement.setAttribute("SortMode", "Every Visit");
    }
}

function thumbstripsFilmstripManagerGetSortMode(sortMode)
{
    var retVal = sortModeFirstVisit;
    
    var sortElement = this.GetCustomSort();
    var sortModeAttribute = sortElement.getAttribute("SortMode");
    
    if(sortModeAttribute!=null)
    {
        if(sortModeAttribute=="Manual")
        {
            retVal = sortModeManually;
        }
        else if(sortModeAttribute=="First Visit")
        {
            retVal = sortModeFirstVisit;
        }
        else if(sortModeAttribute=="Last Visit")
        {
            retVal = sortModeLastVisit;
        }
        else if(sortModeAttribute=="Every Visit")
        {
            retVal = sortModeEveryVisit;
        }
    }

    return retVal;
}

function thumbstripsFilmstripManagerLoadThumbnailsIntoMemory()
{
    var thumbnailElements = this.m_filmstripManager.m_xmlData.documentElement.selectNodes("//" + filmstripTag_PageThumbnails + "/" + filmstripTag_PageThumbnail);
    
    for(var i = 0; i < thumbnailElements.length; i++)
    {
        var targetUrl = thumbnailElements[i].getAttribute(filmstripAttribute_SourceUrl);
        
        var thumbnailLoad = new thumbstripsWebPageThumbnailNode(targetUrl, null, 0, 0, 0);
        thumbnailLoad.ReadFromXml(thumbnailElements[i]);        
        this.m_thumbnailArray.UpdateThumbnail(thumbnailLoad);
    }        
}

var thumbstrips_filmstripObject;

function thumbstrips_GetFilmstrip()
{	
	if(thumbstrips_filmstripObject==null)
	{   
	    thumbstrips_filmstripObject = new thumbstripsFilmstripManager();
	    thumbstrips_filmstripObject.Initialize(true);
	}
    
    return thumbstrips_filmstripObject;
}


