// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- LOAD DIALOG -- //
var sortModeFirstVisit  = 0;
var sortModeLastVisit   = 1;
var sortModeEveryVisit  = 2;
var sortModeManually    = 3;

function thumbstripsSortManager()
{
    this.m_sortMenu = document.getElementById("thumbstrips_sortMenuPopup");
}

thumbstripsSortManager.prototype.ProcessMenuChange = thumbstripsSortManagerProcessMenuChange;
thumbstripsSortManager.prototype.ChangeCurrentSortingPreference = thumbstripsSortManagerChangeCurrentSortingPreference;
thumbstripsSortManager.prototype.SetSortingPreferences = thumbstripsSortManagerSetSortingPreferences;
thumbstripsSortManager.prototype.GetSortingPreferences = thumbstripsSortManagerGetSortingPreferences;
thumbstripsSortManager.prototype.GetSortMode = thumbstripsSortManagerGetSortMode;
thumbstripsSortManager.prototype.SetSortMode = thumbstripsSortManagerSetSortMode;
thumbstripsSortManager.prototype.ShowManualSort = thumbstripsSortManagerShowManualSort;

function thumbstripsSortManagerProcessMenuChange()
{
	var firstVisit = this.m_sortMenu.childNodes[0].getAttribute("checked");
	var lastVisit  = this.m_sortMenu.childNodes[1].getAttribute("checked");
	var everyVisit = this.m_sortMenu.childNodes[2].getAttribute("checked");
    var manualSort = this.m_sortMenu.childNodes[3].getAttribute("checked");
        
    if(firstVisit==="true")
    {
        this.ChangeCurrentSortingPreference(false, false, false, true);	
    }
    else if(lastVisit==="true")
    {
        this.ChangeCurrentSortingPreference(false, false, true, false);	
    }
    else if(everyVisit==="true")
    {
        this.ChangeCurrentSortingPreference(false, true, false, false);	
    }
    else if(manualSort==="true")
    {
        this.ChangeCurrentSortingPreference(true, false, false, false);	
    }
}

function thumbstripsSortManagerChangeCurrentSortingPreference(sortManually, sortEveryVisit, sortLastVisit, sortFirstVisit)
{   
    if(sortManually==true)
    {
        thumbstrips_GetFilmstrip().InitializeCustomSort();
    }     

    this.SetSortingPreferences(sortManually, sortEveryVisit, sortLastVisit, sortFirstVisit);
    thumbstrips_GetFilmstrip().SetSortMode(this.GetSortMode());
}

function thumbstripsSortManagerSetSortingPreferences(sortManually, sortEveryVisit, sortLastVisit, sortFirstVisit, checkToInitialize)
{       
    thumbstrips_prefs.setBoolPref("sorting.first_visit", sortFirstVisit);
	thumbstrips_prefs.setBoolPref("sorting.last_visit", sortLastVisit);
	thumbstrips_prefs.setBoolPref("sorting.every_visit", sortEveryVisit);
	thumbstrips_prefs.setBoolPref("sorting.manual", sortManually);
}

function thumbstripsSortManagerGetSortingPreferences()
{   
    var retVal = new Array();
       
    retVal[0] = thumbstrips_prefs.getBoolPref("sorting.first_visit");
	retVal[1] = thumbstrips_prefs.getBoolPref("sorting.last_visit");
	retVal[2] = thumbstrips_prefs.getBoolPref("sorting.every_visit");
	retVal[3] = thumbstrips_prefs.getBoolPref("sorting.manual");
	
	return retVal;
}

function thumbstripsSortManagerGetSortMode()
{
    var retVal = sortModeFirstVisit;

    if (thumbstrips_prefs.getBoolPref("sorting.every_visit") === true) 
	{	  
	    retVal = sortModeEveryVisit;
	}
	else if(thumbstrips_prefs.getBoolPref("sorting.last_visit") === true) 
	{	  
	    retVal = sortModeLastVisit;
    }
    else if(thumbstrips_prefs.getBoolPref("sorting.first_visit") === true) 
    {   	  
	    retVal = sortModeFirstVisit;
    }
    else if(thumbstrips_prefs.getBoolPref("sorting.manual") === true)
	{   	  
	    retVal = sortModeManually;
    }
    
    return retVal;
}

function thumbstripsSortManagerSetSortMode(sortMode)
{
    if(sortMode==sortModeManually)
    {
        this.SetSortingPreferences(true, false, false, false);
        this.m_sortMenu.childNodes[3].setAttribute("checked", true);
    }
    else if(sortMode==sortModeEveryVisit)
    {
        this.SetSortingPreferences(false, true, false, false);
        this.m_sortMenu.childNodes[2].setAttribute("checked", true);
    }
    else if(sortMode==sortModeLastVisit)
    {
        this.SetSortingPreferences(false, false, true, false);
        this.m_sortMenu.childNodes[1].setAttribute("checked", true); 
    }
    else
    {
        this.SetSortingPreferences(false, false, false, true);
        this.m_sortMenu.childNodes[0].setAttribute("checked", true);
    } 
}

function thumbstripsSortManagerShowManualSort(showManualSortOption)
{
    var manualSort = this.m_sortMenu.childNodes[3];
    
    if(showManualSortOption==true)
    {
        manualSort.hidden = false;
    }
    else
    {
        manualSort.hidden = true;
    }
}