// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// All Rights Reserved. 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- INITIALIZATION -- //
function thumbstripsThumbnail()
{
    this.m_canvas = null;
}

thumbstripsThumbnail.prototype.CopyImage = thumbstripsThumbnailCopyImage;
thumbstripsThumbnail.prototype.CreateNewCanvas = thumbstripsThumbnailCreateNewCanvas;
thumbstripsThumbnail.prototype.CopyToCanvas = thumbstripsThumbnailCopyToCanvas;
thumbstripsThumbnail.prototype.Destroy = thumbstripsThumbnailDestroy;
thumbstripsThumbnail.prototype.GetPageContent = thumbstripsThumbnailGetPageContent;
thumbstripsThumbnail.prototype.InitializeFromSourceUrl = thumbstripsThumbnailInitializeFromSourceUrl;
thumbstripsThumbnail.prototype.InitializeFromDataUrl = thumbstripsThumbnailInitializeFromDataUrl;
thumbstripsThumbnail.prototype.ToDataUrl = thumbstripsThumbnailToDataUrl;
thumbstripsThumbnail.prototype.UpdateCanvas = thumbstripsThumbnailUpdateCanvas;
thumbstripsThumbnail.prototype.CopyCanvas = thumbstripsThumbnailCopyCanvas;
thumbstripsThumbnail.prototype.Resize = thumbstripsThumbnailResize;


function thumbstripsThumbnailDestroy()
{
    if(this.m_canvas!=null)
    {
        this.m_canvas = null;
    }
}

function thumbstripsThumbnailGetPageContent()
{
    return content;
}

function thumbstripsThumbnailInitializeFromSourceUrl(targetUrl)
{
    this.m_canvas = document.createElementNS("http://www.w3.org/1999/xhtml", "canvas");
	
	this.m_canvas.setAttribute("SourceUrl", targetUrl);
    this.m_canvas.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");

	this.m_canvas.setAttribute("class", thumbstrips_thumbnailClass);
    this.m_canvas.setAttribute("id", thumbstrips_thumbnailClass + targetUrl);
    this.m_canvas.setAttribute("flex", 0);

    this.m_canvas.height = thumbstrips_prefs.getIntPref("style.thumb_max_height");
    this.m_canvas.displayHeight = thumbstrips_currentHeight;

    this.m_canvas.style.height = this.m_canvas.displayHeight + "px";
    this.m_canvas.style.minHeight = this.m_canvas.style.height;
    this.m_canvas.style.maxHeight = this.m_canvas.style.height;

    this.m_canvas.width = 0;
    this.m_canvas.displayWidth = 0;

    this.m_canvas.style.width = this.m_canvas.displayWidth + "px";
    this.m_canvas.style.minWidth = this.m_canvas.style.width;
    this.m_canvas.style.maxWidth = this.m_canvas.style.width;
  
     this.m_canvas.setAttribute("hiddenWhileLoading", "true");
}

function thumbstripsThumbnailInitializeFromDataUrl(parentObject, dataUrl)
{
    this.InitializeFromSourceUrl(parentObject.m_url);
    
	var targetImage = new Image()        

    targetImage.onload=function()
    {       
        var targetThumbnail = thumbstrips_GetFilmstrip().m_thumbnailArray.FindByUrl(this.getAttribute("SourceUrl"));     
                
        if(this.height === 0 || this.width === 0) 
        {    
            // bad dataURL
            thumbstrips_log("bad dataURL");
            targetThumbnail.m_pageThumbnail.m_canvas.setAttribute("hidden", "true");
            return;
        }

        //	thumb.removeAttribute("hidden");		
        targetThumbnail.m_pageThumbnail.m_canvas.width = this.width * targetThumbnail.m_pageThumbnail.m_canvas.height / this.height;
        targetThumbnail.m_pageThumbnail.m_canvas.displayWidth = targetThumbnail.m_pageThumbnail.m_canvas.width * targetThumbnail.m_pageThumbnail.m_canvas.displayHeight / targetThumbnail.m_pageThumbnail.m_canvas.height;
        targetThumbnail.m_pageThumbnail.m_canvas.style.width = targetThumbnail.m_pageThumbnail.m_canvas.displayWidth + "px";
        targetThumbnail.m_pageThumbnail.m_canvas.style.minWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;
        targetThumbnail.m_pageThumbnail.m_canvas.style.maxWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;

        var ctx = targetThumbnail.m_pageThumbnail.m_canvas.getContext("2d");
        ctx.drawImage(this, 0, 0, this.width, this.height, 0, 0, targetThumbnail.m_pageThumbnail.m_canvas.width, targetThumbnail.m_pageThumbnail.m_canvas.height);	 
        ctx = null;
        
        thumbstrips_GetFilmstrip().UpdateWebsiteNode(null, targetThumbnail.m_url);
        
        targetThumbnail.m_lastUpdateDate = null;
        targetThumbnail.m_lastUpdateDate = new Date();  
        
        var renderer = new thumbstripsFilmstripRenderer();
        renderer.Draw(false);
        renderer = null;          
    }
    
//    targetImage.setAttribute("onload", "thumbstripsThumbnailCopyImage(this, '" + parentObject.m_url + "');");
//    window.setTimeout(thumbstripsThumbnailCopyImage, 10000, targetImage, parentObject.m_url);
  	
    targetImage.setAttribute("SourceUrl", parentObject.m_url);
    thumbstrips_GetFilmstrip().m_thumbnailArray.UpdateThumbnail(parentObject);

	if(dataUrl===thumbstrips_emptyThumbnailSignal)
	{
		targetImage.src = "chrome://thumbstrips/skin/emptyThumb.png";
    }
    else
    {	    
        targetImage.src = dataUrl;
    }

}

function thumbstripsThumbnailToDataUrl()
{
    var retVal = "";
    
    if(this.m_canvas!=null)
    {
        try
        {        
            retVal = this.m_canvas.toDataURL();
        }
        catch(e)
        {
            thumbstrips_log(e);
        }
    }
    
    return retVal;
}

function thumbstripsThumbnailUpdateCanvas(parentWebPageNode)
{
    var pageContent = this.GetPageContent();
    
	var context = this.m_canvas.getContext("2d");
	
	var wPage = pageContent.innerWidth - 16;
	var hPage = pageContent.innerHeight - 16;
	
	var renderer = new thumbstripsFilmstripRenderer();
	hPage += renderer.GetTrayHeight();
    				
	var scale = this.m_canvas.height / hPage;
	var oldWidth = this.m_canvas.width;
		
	this.m_canvas.width = wPage * scale;
	this.m_canvas.displayWidth = this.m_canvas.displayHeight * this.m_canvas.width / this.m_canvas.height;
		
	this.m_canvas.style.width = this.m_canvas.displayWidth + "px";
	this.m_canvas.style.minWidth = this.m_canvas.style.width;
	this.m_canvas.style.maxWidth = this.m_canvas.style.width;
		
	context.save();
    context.scale(scale, scale);
	
	context.drawWindow(pageContent, parentWebPageNode.m_scrollX, parentWebPageNode.m_scrollY, wPage, hPage, "rgba(255,255,255,1)");
		
	context.restore();
	
		// After the width is set, unhide the canvas
	//if (canvas.getAttribute("hidden") === "true" && canvas.displayWidth > 0) {
	
	if (this.m_canvas && this.m_canvas.getAttribute("hidden") === "true" && this.m_canvas.displayWidth > 0) 
	{
		this.m_canvas.removeAttribute("hidden");
		
		//the above commented code has been moved to:
		thumbstrips_skipToCurrent();
	}
	
	renderer = null;
	pageContent = null;
	context = null;
}
// send copyOthers = true if you want it to copy the image onto other canvases
// for the same url as well (i.e. when sorting with every visit)
function thumbstripsThumbnailCopyImage(sourceImage, targetUrl) 
{
    var targetThumbnail = thumbstrips_GetFilmstrip().m_thumbnailArray.FindByUrl(targetUrl);     
    
    if(sourceImage.height === 0 || sourceImage.width === 0) 
    {    
        // bad dataURL
        thumbstrips_log("bad dataURL");
        targetThumbnail.m_pageThumbnail.m_canvas.setAttribute("hidden", "true");
        return;
    }

    //	thumb.removeAttribute("hidden");		
    targetThumbnail.m_pageThumbnail.m_canvas.width = sourceImage.width * targetThumbnail.m_pageThumbnail.m_canvas.height / sourceImage.height;
    targetThumbnail.m_pageThumbnail.m_canvas.displayWidth = targetThumbnail.m_pageThumbnail.m_canvas.width * targetThumbnail.m_pageThumbnail.m_canvas.displayHeight / targetThumbnail.m_pageThumbnail.m_canvas.height;
    targetThumbnail.m_pageThumbnail.m_canvas.style.width = targetThumbnail.m_pageThumbnail.m_canvas.displayWidth + "px";
    targetThumbnail.m_pageThumbnail.m_canvas.style.minWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;
    targetThumbnail.m_pageThumbnail.m_canvas.style.maxWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;

    var ctx = targetThumbnail.m_pageThumbnail.m_canvas.getContext("2d");
    ctx.drawImage(sourceImage, 0, 0, sourceImage.width, sourceImage.height, 0, 0, targetThumbnail.m_pageThumbnail.m_canvas.width, targetThumbnail.m_pageThumbnail.m_canvas.height);	 
    ctx = null;
    
    thumbstrips_GetFilmstrip().UpdateWebsiteNode(null, targetThumbnail.m_url);
    
    targetThumbnail.m_lastUpdateDate = null;
    targetThumbnail.m_lastUpdateDate = new Date();  
    
    var renderer = new thumbstripsFilmstripRenderer();
    renderer.Draw(false);
    renderer = null;      
}

function thumbstripsThumbnailCopyCanvas(sourceCanvas)
{
    var img = sourceCanvas.m_canvas;
    var thumb = this.m_canvas;
	
	thumb.width = img.width * thumb.height / img.height;
	thumb.displayWidth = thumb.width * thumb.displayHeight / thumb.height;

	thumb.style.width = thumb.displayWidth + "px";
	thumb.style.minWidth = thumb.style.width;
	thumb.style.maxWidth = thumb.style.width;
	
	var ctx = thumb.getContext("2d");
	
	ctx.drawImage(img, 0, 0, img.width, img.height, 0, 0, thumb.width, thumb.height);
}

function thumbstripsThumbnailCreateNewCanvas()
{
    var retVal = document.createElementNS("http://www.w3.org/1999/xhtml", "canvas");
    var sourceUrl = this.m_canvas.getAttribute("SourceUrl");	

	retVal.setAttribute("SourceUrl", sourceUrl);
    retVal.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");

	retVal.setAttribute("class", thumbstrips_thumbnailClass);
    retVal.setAttribute("id", thumbstrips_thumbnailClass + sourceUrl);
    retVal.setAttribute("flex", 0);

	retVal.minHeight = this.m_canvas.minHeight;
	retVal.style.height = this.m_canvas.style.height;
	retVal.style.maxHeight = this.m_canvas.style.maxHeight;

    retVal.height = this.m_canvas.height;
    retVal.displayHeight = this.m_canvas.displayHeight;
    	
	retVal.width = this.m_canvas.width;
	retVal.displayWidth = this.m_canvas.displayWidth;
	
	retVal.style.width = this.m_canvas.style.width;
	retVal.style.minWidth = this.m_canvas.style.minWidth;
	retVal.style.maxWidth = this.m_canvas.style.maxWidth;
	
	var ctx = retVal.getContext("2d");
	ctx.drawImage(this.m_canvas, 0, 0, this.m_canvas.width, this.m_canvas.height, 0, 0, retVal.width, retVal.height);
	ctx = null;
	
    return retVal;
}

function thumbstripsThumbnailCopyToCanvas(targetCanvas)
{
    targetCanvas.height = this.m_canvas.height;
    targetCanvas.displayHeight = this.m_canvas.displayHeight;
    
	targetCanvas.minHeight = this.m_canvas.minHeight;
	targetCanvas.style.height = this.m_canvas.style.height;
	targetCanvas.style.maxHeight = this.m_canvas.style.maxHeight;
	
	targetCanvas.width = this.m_canvas.width;
	targetCanvas.displayWidth = this.m_canvas.displayWidth;
	
	targetCanvas.style.width = this.m_canvas.style.width;
	targetCanvas.style.minWidth = this.m_canvas.style.minWidth;
	targetCanvas.style.maxWidth = this.m_canvas.style.maxWidth;
	
	var ctx = targetCanvas.getContext("2d");
	ctx.drawImage(this.m_canvas, 0, 0, this.m_canvas.width, this.m_canvas.height, 0, 0, targetCanvas.width, targetCanvas.height);
	ctx = null;
}
