// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// webpagenode.js

var thumbstrips_WN_CHECK_REP = true;

function thumbstripsWebPageVisitNode(url, visitList) 
{
	this.m_url = url;
	
	if(url!=null)
	    this.m_url = url;
	    
	this.m_domain = thumbstrips_trimDomainFromUrl(this.m_url);
    
    if(visitList!=null)
    {
        this.m_visitList = new Array(visitList.length);
        
        for(var visitItem in visitList)
            this.m_visitList[visitItem] = new Date(visitList[visitItem]);
    }
    else
    {
        this.m_visitList = new Array(1);
        this.m_visitList[0] = new Date();
    }     
}	

thumbstripsWebPageVisitNode.prototype.Destroy = thumbstripsWebPageVisitNodeDestroy;
thumbstripsWebPageVisitNode.prototype.BeginNewVisit = thumbstripsWebPageVisitNodeBeginNewVisit;
thumbstripsWebPageVisitNode.prototype.UpdateCurrentVisit = thumbstripsWebPageVisitNodeUpdateCurrentVisit;
thumbstripsWebPageVisitNode.prototype.ReadFromXml = thumbstripsWebPageVisitNodeReadFromXml;

function thumbstripsWebPageVisitNodeDestroy()
{
    if(this.m_visitList!=null)
    {
        for(var i = this.m_visitList.length; i >= 0; i--)
        {
            this.m_visitList[i] = null;
        }
        
        this.m_visitList = null;
    }
}

function thumbstripsWebPageVisitNodeBeginNewVisit()
{
    this.m_visitList[this.m_visitList.length] = new Date();
}	

function thumbstripsWebPageVisitNodeUpdateCurrentVisit(dontAddTime, visitTimeInMilliseconds)
{	
	var temp = new Date();
		
	if (!dontAddTime) 
	{
		visitTimeInMilliseconds += (temp - this.m_visitList[this.m_visitList.length - 1]);
	}
    		
	this.m_visitList[this.m_visitList.length - 1] = temp;	
	
	return visitTimeInMilliseconds;
};

function thumbstripsWebPageVisitNodeReadFromXml(visitItems)
{
    if(visitItems.length > 0)
    {
        this.m_url = visitItems[0].getAttribute("SourceUrl");
        this.m_domain = visitItems[0].getAttribute("Domain");
       
        this.m_visitList = new Array(visitItems.length);
        
        for(var i = 0; i < visitItems.length; i++)
        {
            this.m_visitList[i] = new Date(visitItems[i].getAttribute("VisitDate"));
        }
    }
}